class Solution {
    searchRange(nums, target) {
        // Initialize the result array with -1, -1 (default values if target not found)
        let result = [-1, -1];
        
        // Binary search to find the first occurrence of the target
        let start = 0, end = nums.length - 1;
        while (start <= end) {
            // Calculate the middle index
            let mid = Math.floor(start + (end - start) / 2);
            
            if (nums[mid] === target) {
                // If target is found, update the first index
                result[0] = mid;
                // Move left to search for an earlier occurrence
                end = mid - 1;
            } else if (nums[mid] < target) {
                // If the middle element is less than the target, search the right half
                start = mid + 1;
            } else {
                // If the middle element is greater than the target, search the left half
                end = mid - 1;
            }
        }

        // If the target was not found in the first binary search, return [-1, -1]
        if (result[0] === -1) {
            return result;
        }

        // Binary search to find the last occurrence of the target
        start = 0;
        end = nums.length - 1;
        while (start <= end) {
            // Calculate the middle index
            let mid = Math.floor(start + (end - start) / 2);
            
            if (nums[mid] === target) {
                // If target is found, update the last index
                result[1] = mid;
                // Move right to search for a later occurrence
                start = mid + 1;
            } else if (nums[mid] < target) {
                // If the middle element is less than the target, search the right half
                start = mid + 1;
            } else {
                // If the middle element is greater than the target, search the left half
                end = mid - 1;
            }
        }

        return result;
    }
}

// Example usage:
let solution = new Solution();
console.log(solution.searchRange([5, 7, 7, 8, 8, 10], 8)); // Output: [3, 4]
